# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

# If you want to build with maven, 
# give rpmbuild option '--with maven'

%define with_maven %{?_with_maven:1}%{!?_with_maven:0}
%define without_maven %{!?_with_maven:1}%{?_with_maven:0}

%define section     free

Name:           maven-model
Version:        3.0.2
Release:        5%{?dist}
Epoch:          0
Summary:        Maven Model
License:        Apache Software License 2.0
Group:          Development/Java
URL:            http://maven.apache.org/

# svn export http://svn.apache.org/repos/asf/maven/components/tags/maven-model-3.0.2
Source0:        maven-model-3.0.2-src.tar.gz
Source1:        nomaven-model-3.0.2-build.xml
Source2:        maven-model-3.0.2.pom
Patch0:         maven-model-3.0.2-pom.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:5.0.0
BuildRequires:  java-devel >= 0:1.6.0
%if %{with_maven}
BuildRequires:  maven
BuildRequires:  maven-plugin-modello
%endif
BuildRequires:  bea-stax-api
BuildRequires:  classworlds >= 0:1.1
BuildRequires:  dom4j
BuildRequires:  modello >= 0:1.0-0.a15
BuildRequires:  plexus-utils
BuildRequires:  plexus-container-default
BuildRequires:  stax-utils

Requires(post):    jpackage-utils >= 0:5.0.0
Requires(postun):  jpackage-utils >= 0:5.0.0

Requires:  java >= 0:1.6.0
Requires:  plexus-utils
Requires:  stax-utils >= 0:0.0-0.20060502

%description
Maven's model for Java project.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %{with_maven}
%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.
%endif

%prep
%setup -q -n %{name}-%{version}
cp %{SOURCE1} build.xml

%patch0 -b .sav0

%build
%if %{with_maven}
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p ${MAVEN_REPO_LOCAL}
export MAVEN_OPTS="-Dmaven2.jpp.mode=true -Dmaven.repo.local=${MAVEN_REPO_LOCAL}"
%{_bindir}/mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        install
cp target/%{name}-%{version}.jar .
%{_bindir}/mvn-jpp \
        -e \
        -P all-models \
        -s $(pwd)/settings.xml \
        install javadoc:javadoc site
cp %{name}-%{version}.jar target

%else

export CLASSPATH=$(build-classpath \
bea-stax-api \
classworlds \
dom4j \
jdom \
modello/core \
modello/plugin-dom4j \
modello/plugin-jdom \
modello/plugin-stax \
modello/plugin-xml \
modello/plugin-xpp3 \
modello/plugin-xsd \
plexus/classworlds \
plexus/container-default \
plexus/utils \
stax-utils \
)

java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo java target/generated-sources 4.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo xsd  target/generated-sources 4.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo jdom-writer target/generated-sources 4.0.0 false
#
java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo xpp3-reader target/generated-sources 4.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo xpp3-writer target/generated-sources 4.0.0 false
#
java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo dom4j-reader target/generated-sources 4.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo dom4j-writer target/generated-sources 4.0.0 false
#
java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo stax-reader target/generated-sources 4.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo stax-writer target/generated-sources 4.0.0 false
#
java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo java target/generated-sources 3.0.0 true
java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo xsd  target/generated-sources 3.0.0 true
#java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo jdom-writer  target/generated-sources 3.0.0 true
#
java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo xpp3-reader target/generated-sources 3.0.0 true
java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo xpp3-writer target/generated-sources 3.0.0 true
#
java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo dom4j-reader target/generated-sources 3.0.0 true
java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo dom4j-writer target/generated-sources 3.0.0 true
#
java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo stax-reader target/generated-sources 3.0.0 true
java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo stax-writer target/generated-sources 3.0.0 true



#    <!-- Need the original package as well -->
#    <ant:copy tofile="target/maven.mdo.m1" file="maven.mdo" />
#    <ant:replace file="target/maven.mdo.m1" token="org.apache.maven.model" value="org.apache.maven.project" />
sed -e 's/org\.apache\.maven\.model/org.apache.maven.project/' src/main/mdo/maven.mdo > target/maven.mdo.m1
#    <modello:generate model="target/maven.mdo.m1" type="java" packageWithVersion="false" version="3.0.0" targetDirectory="target/generated-sources" />
java org.codehaus.modello.ModelloCli target/maven.mdo.m1 java target/generated-sources 3.0.0 false
#    <modello:generate model="target/maven.mdo.m1" type="xpp3-reader" packageWithVersion="false" version="3.0.0" targetDirectory="target/generated-sources" />
java org.codehaus.modello.ModelloCli target/maven.mdo.m1 xpp3-reader target/generated-sources 3.0.0 false
#    <modello:generate model="target/maven.mdo.m1" type="xpp3-writer" packageWithVersion="false" version="3.0.0" targetDirectory="target/generated-sources" />
java org.codehaus.modello.ModelloCli target/maven.mdo.m1 xpp3-writer target/generated-sources 3.0.0 false
#
java org.codehaus.modello.ModelloCli target/maven.mdo.m1 dom4j-reader target/generated-sources 3.0.0 false
java org.codehaus.modello.ModelloCli target/maven.mdo.m1 dom4j-writer target/generated-sources 3.0.0 false
java org.codehaus.modello.ModelloCli target/maven.mdo.m1 stax-reader target/generated-sources 3.0.0 false
java org.codehaus.modello.ModelloCli target/maven.mdo.m1 stax-writer target/generated-sources 3.0.0 false

ant -Dbuild.sysclasspath=only jar javadoc

%endif


%install
rm -rf $RPM_BUILD_ROOT
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 target/%{name}-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 target/%{name}-%{version}-all.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-all-%{version}.jar
%add_to_maven_depmap maven %{name} %{version} JPP %{name}
%add_to_maven_depmap maven %{name}-all %{version} JPP %{name}-all
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)


# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{with_maven}
# manual
rm -rf target/site/apidocs 
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/site/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root,-)
%{_javadir}/*
%{_mavendepmapfragdir}/*
%{_datadir}/maven2/poms/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%if %{with_maven}
%files manual
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}-%{version}
%endif

%changelog
* Tue Sep 07 2010 Ralph Apel <r.apel at r-apel.de> - 0:3.0.2-5
- Restore m1 classes (/project/ instead of /model/)

* Fri Oct 30 2009 Ralph Apel <r.apel at r-apel.de> - 0:3.0.2-4
- Add maven-model-all.jar (to include v3.0.0 model)
- Fix ant build
- Optionally build with maven2

* Mon Mar 16 2009 Ralph Apel <r.apel at r-apel.de> - 0:3.0.2-3.jpp5
- First JPP-5 build

* Mon Aug 27 2007 Ralph Apel <r.apel at r-apel.de> - 0:3.0.2-2jpp
- Require newer stax-utils for runtime

* Fri Aug 24 2007 Ralph Apel <r.apel at r-apel.de> - 0:3.0.2-1jpp
- Updated to 3.0.2
- Add pom and depmap frags

* Thu Dec 22 2005 Deepak Bhole <dbhole@redhat.com> - 0:3.0.1-1jpp
- Updated to 3.0.1

* Mon Nov 07 2005 Ralph Apel <r.apel at r-apel.de> - 0:3.0.0-1jpp
- First JPackage build

